#ifndef dud4_playerdata_hh
#define dud4_playerdata_hh

#include <string>
#include "playertask.hh"

class playerdata
{
	static const bool BROKEN_TERM = true;
	static const bool SUPPORT_2x  = false;
	static const bool COLOURS     = true;
	
private:
	friend class playertask;
	
	playertask &owner;
	mutable int attr;
	
	// -1 = colour is now unreliable
	// other = new color.
    void colour(int newattr) const;

	void resize(unsigned x, unsigned y)
	{	
		cols = x;
		lines = y;
	}
    
    void displayprompt()
    {
    	litecho(prompt);
    	save_ok = true;
    }
    
    inline const std::string playerfilename() const
    {
    	return playerfilename(name);
    }
    
    const std::string playerfilename(const std::string &whom) const
    {
    	return "players/" + whom;
    }

    void byebye(const std::string &reason);
    
	void load()
	{
		load(name);
	}
	
	void load(const std::string &whom);
	void save();

public:
	enum situation
	{
		// Never add new situations in the
		// middle, always add them to the end!
		S_LOGIN = 0,
		S_GAME,
		S_LOGINPASS,
		S_CREATE,
		S_PASSCHECK
	} situation;
	
	std::string name;
	std::string pass;
	std::string prompt;
	time_t creation;
	
	unsigned lines, cols;	
	bool save_ok;
	
public:
	playerdata(playertask &o) : owner(o),
	                            situation(S_LOGIN),
	                            lines(80), cols(24),
	                            save_ok(false)
	{
		colour(-1);
	}
	void startup()
	{
		colour(7);
    	litecho(
    	    "`F---------------------------------------------------------------------------\n"
    	    "`2*** `ADUD4 `2runtime - copyright (C) `A1992`2,`A2000`F Bisqwit`2 (`Bhttp://iki.fi/bisqwit/`2)\n"
    	    "`F---------------------------------------------------------------------------\n"
    	    "`3DUD login v"VERSION" - recommended to have square font.\n"
    	    "`7\n");

    	owner.setprompt("Enter your character name (case insignificant): ",
    	                10,
    	                true,
    	                "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ ");
	}
	
	~playerdata();
	
    void litecho(const std::string &s) const;
    
	void handleinput();	
	void takecareof(const class event &ev);
};

#endif
