#include <iostream>
#include <poll.h>
#include <vector>
#include <unistd.h>

#include "taskmanager.hh"
#include "task.hh"

taskmanager::taskmanager()
{
}

taskmanager::~taskmanager()
{
    std::list<task *>::iterator i;
    
    std::cout << "Killing all tasks...\n";
    
    for(i=tasks.begin(); i!=tasks.end(); ++i)
        delete *i;
        
    std::cout << "Taskmanager going down.\n";
}

void taskmanager::insert(task *n)
{
    tasks.push_back(n);
}

void taskmanager::tick()
{
    std::list<task *>::iterator i, j;
    for(i=tasks.begin(); i!=tasks.end(); i = j)
    {
        j = i;
        ++j;
        if(!(*i)->tick())
        {
            delete *i;
            tasks.erase(i);
        }
    }
    
    unsigned pollcount = 0;
    for(i=tasks.begin(); i!=tasks.end(); ++i)
        pollcount += (*i)->numpolls();
    
    std::vector<struct pollfd> polls(pollcount);

    pollcount = 0;
    for(i=tasks.begin(); i!=tasks.end(); ++i)
    {
        (*i)->writepolls(&polls[pollcount]);
        pollcount += (*i)->numpolls();
    }
    
    if(pollcount)
    {
        poll(&polls[0], pollcount, 1000);
        pollcount = 0;
        for(i=tasks.begin(); i!=tasks.end(); ++i)
        {
            (*i)->checkpolls(&polls[pollcount]);
            pollcount += (*i)->numpolls();
        }
    }
    else
    	usleep(1000*1000);
}

void taskmanager::operator+= (const class event &ev)
{
    std::list<task *>::iterator i;
    for(i=tasks.begin(); i!=tasks.end(); ++i)
        **i += ev;
}
